'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _index = require('./middle-ware/concat/index');

var _index2 = _interopRequireDefault(_index);

var _config = require('../config.json');

var _config2 = _interopRequireDefault(_config);

var _koa2Static = require('koa2-static');

var _koa2Static2 = _interopRequireDefault(_koa2Static);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CabinDevServer = function () {
    function CabinDevServer(options) {
        _classCallCheck(this, CabinDevServer);

        this.options = options;
        this.init();
        this.init.bind(this);
        this.start.bind(this);
        this.stop.bind(this);
    }

    _createClass(CabinDevServer, [{
        key: 'init',
        value: function init() {
            var _this = this;

            this.app = new _koa2.default();
            var concat = new _index2.default({ 'staticPath': this.options.staticPath });
            this.app.use(concat.init);
            this.app.use((0, _koa2Static2.default)({
                'path': '',
                'root': this.options.staticPath + '/'
            }));
            this.app.use(function () {
                var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(ctx) {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    ctx.body = 'resource not found';

                                case 1:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, _this);
                }));

                return function (_x) {
                    return _ref.apply(this, arguments);
                };
            }());
        }
    }, {
        key: 'start',
        value: function start() {
            this.app.listen(this.options.port);
            console.log('[cabin] server start at port:' + this.options.port);
        }
    }, {
        key: 'stop',
        value: function stop() {
            this.app.stop();
            console.log('[cabin] server stopped');
        }
    }]);

    return CabinDevServer;
}();

exports.default = CabinDevServer;